﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public class HiveExperimentPermission : HiveItemBase {
    [DataMember]
    public Guid HiveExperimentId { get; set; }
    [DataMember]
    public Guid GrantedUserId { get; set; }
    [DataMember]
    public Guid GrantedByUserId { get; set; }
    [DataMember]
    public Permission Permission { get; set; }

    public HiveExperimentPermission() { }

    protected HiveExperimentPermission(HiveExperimentPermission original, Cloner cloner) : base(original, cloner) {
      this.HiveExperimentId = original.HiveExperimentId;
      this.GrantedUserId = original.GrantedUserId;
      this.GrantedByUserId = original.GrantedByUserId;
      this.Permission = original.Permission;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new HiveExperimentPermission(this, cloner);
    }
  }
}
